void basic()
{
        asm{
                JP 1A19h
           };
}

void pokeb(int addr, char byte)
{
        asm{
                LD      L,(IX-03)       ; HL = addr      
                LD      H,(IX-02)       
                LD      A,(IX-01)       ; A = byte
                LD      (HL),A          ; load byte into address
           };
}

char peekb(int addr)
{
        asm{
                LD      L,(IX-02)
                LD      H,(IX-01)
                LD      A,(HL)
           };
}

void memmove(int saddr, int daddr, int numbytes)
{
        asm{
                LD      L,(IX-06)
                LD      H,(IX-05)
                LD      E,(IX-04)
                LD      D,(IX-03)
                LD      C,(IX-02)
                LD      B,(IX-01)
                LDIR
            };
}


void memfill(int addr, int numbytes, char value)
{
        asm{
                LD      L,(IX-05)
                LD      H,(IX-04)
                LD      C,(IX-03)
                LD      B,(IX-02)
MEMFILL1:  
                LD      A,(IX-01)
                LD      (HL),A
                INC     HL
                DEC     BC
                LD      A,B
                OR      C
                JR      NZ,MEMFILL1
            };
}

void printc(char c)
{
        asm{
                LD      A,(IX-01)
                CALL    033Ah
           };
}

void prints(char *s)
{
        asm{
                LD      L,(IX-02)
                LD      H,(IX-01)
                PUSH    AF
                PUSH    BC
                PUSH    DE
                PUSH    HL
                PUSH    IX
                PUSH    IY
                CALL    28A7h
                POP     IY
                POP     IX
                POP     HL
                POP     DE
                POP     BC
                POP     AF
           };
}

void cls()
{
        asm{
                PUSH    AF
                PUSH    BC
                PUSH    DE
                PUSH    HL
                PUSH    IX
                PUSH    IY
                CALL    01C9h
                POP     IY
                POP     IX
                POP     HL
                POP     DE
                POP     BC
                POP     AF
           };
}

void sound(int freq, int cycles)
{
        asm{
                LD      L,(IX-04)
                LD      H,(IX-03)
                LD      C,(IX-02)
                LD      B,(IX-01)
                PUSH    AF
                PUSH    BC
                PUSH    DE
                PUSH    HL
                PUSH    IX
                PUSH    IY
                CALL    345Ch
                POP     IY
                POP     IX
                POP     HL
                POP     DE
                POP     BC
                POP     AF
           };
}

char getkey()
{
        asm{
                PUSH    BC
                PUSH    DE
                PUSH    HL
                CALL    2EF4h   ; keycode in A reg
                POP     HL
                POP     DE
                POP     BC
           };
}

void pset(char x, char y, char c)
{
        asm{
        LD      L, (IX-02)              ; get Y coordinate
        LD      H,0                     ; make 16 bit
        ADD     HL,HL                   ; multiple * 2
        ADD     HL,HL                   ; multiple * 4
        ADD     HL,HL                   ; multiple * 8
        ADD     HL,HL                   ; multiple * 16
        ADD     HL,HL                   ; multiple * 32
        LD      DE,28672                ; start of screen mem
        ADD     HL,DE                   ; DE has address of screen row
        LD      A,(IX-03)               ; get X coordinate
        LD      E,A                     ; setup for 16 bit add
        SRL     E                       ; divide by 2
        SRL     E                       ; divide by 4
        LD      D,0
        ADD     HL,DE                   ; DE points to correct screen byte
        SLA     E                       ; multiply by 2
        SLA     E                       ; multiply by 4
        SUB     E                       ; A has remainder - 0,1,2,3
        LD      B,A                     ; set up for djnz
        INC     B
        LD      C,(IX-01)               ; get color
        LD      D,11111100b             ; pixel mask
PSET1:  RRC     C
        RRC     C                       ; adjust color                       
        RRC     D
        RRC     D                       ; adjust pixel mask
        DJNZ    PSET1                   ; C has color, D has mask
        LD      A,(HL)                  ; get byte
        AND     D                       ; mask out pixel
        OR      C                       ; set pixel to color
        LD      (HL),A                  ; and display
        };
}
